function withLogging (peer) {
  const newPeer = Object.create(peer)
  return Object.assign(newPeer, {
    call (method, param) {
      console.log(
        `Calling method ${method} with param ${JSON.stringify(param, null, 2)}`
      )
      return peer.call(method, param)
    },
    set (resource, value) {
      console.log(
        `Setting ${resource} value to ${JSON.stringify(value, null, 2)}`
      )
      return peer.set(resource, value)
    }
  })
}

module.exports = {
  withLogging
}
